# BEGIN COPYRIGHT BLOCK
# (C) 2006 Red Hat, Inc.
# All rights reserved.
# END COPYRIGHT BLOCK

%define nspr_version    4.6.5
%define nss_version     3.11.4

%ifos Linux
%define nspr_name       dirsec-nspr
%define nspr_devel_name dirsec-nspr-devel
%define nss_name        dirsec-nss
%define nss_devel_name  dirsec-nss-devel
%endif

%ifos Solaris
%ifarch sparc
%define base_nspr_name   dirsec-nspr
%define nspr_name        RHATdirsec-nspr
%define nspr_devel_name  RHATdirsec-nspr-devel
%define base_nss_name    dirsec-nss
%define nss_name         RHATdirsec-nss
%define nss_devel_name   RHATdirsec-nss-devel
%endif
%ifarch sparcv9
%define base_nspr_name  dirsec-nspr
%define nspr_name       RHATdirsec-nsprx
%define nspr_devel_name RHATdirsec-nsprx-devel
%define base_nss_name   dirsec-nss
%define nss_name        RHATdirsec-nssx
%define nss_devel_name  RHATdirsec-nssx-devel
%endif
%endif

Name:             dirsec-jss
Version:          4.2.4
Release:          41%{?dist}
Summary:          Java Security Services (JSS)
License:          MPL/GPL/LGPL
URL:              http://www.mozilla.org/projects/security/pki/jss/
Group:            System Environment/Libraries
%ifos Linux
BuildRoot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:    %{nss_name} >= %{nss_version},%{nss_devel_name} >= %{nss_version},%{nspr_name} >= %{nspr_version},%{nspr_devel_name} >= %{nspr_version}, java-1.4.2-ibm, java-1.4.2-ibm-devel
%else
BuildRoot:        %{_builddir}/%{name}-root
BuildRequires:    %{nss_name} >= %{nss_version},%{nss_devel_name} >= %{nss_version},%{nspr_name} >= %{nspr_version},%{nspr_devel_name} >= %{nspr_version}
%endif
Requires:         %{nspr_name} >= %{nspr_version},%{nss_name} >= %{nss_version}
Source:           %{name}-%{version}.tar.gz
%ifarch sparc
SUNW_Pkg:         RHATdirsec-jss
%endif
%ifarch sparcv9
SUNW_Pkg:         RHATdirsec-jssx
%endif
%ifos Solaris
SourcePackage:    RHATdirsec-jss-src
%endif

# patches
Patch1: dirsec-jss-requireclientauth.patch

%description
Java Security Services (JSS) is a java native interface which provides a bridge
for java-based applications to use native Network Security Services (NSS).

%prep

%setup -q

%patch1 -p0

%build

# Enable compiler optimizations and disable debugging code
BUILD_OPT=1
export BUILD_OPT

# Generate symbolic info for debuggers
XCFLAGS="-g $RPM_OPT_FLAGS"
export XCFLAGS

%ifarch i386
NSPR_INCLUDE_DIR=`/usr/bin/pkg-config --variable=includedir %{nspr_name}`
NSPR_LIB_DIR=`/usr/bin/pkg-config --variable=libdir %{nspr_name}`
NSS_INCLUDE_DIR=`/usr/bin/pkg-config --variable=includedir %{nss_name}`
NSS_LIB_DIR=`/usr/bin/pkg-config --variable=libdir %{nss_name}`
%endif

%ifarch x86_64
NSS_INCLUDE_DIR=`PKG_CONFIG_PATH=/usr/lib64/pkgconfig /usr/bin/pkg-config --variable=includedir %{nss_name}`
NSS_LIB_DIR=`PKG_CONFIG_PATH=/usr/lib64/pkgconfig /usr/bin/pkg-config --variable=libdir %{nss_name}`
NSPR_INCLUDE_DIR=`PKG_CONFIG_PATH=/usr/lib64/pkgconfig /usr/bin/pkg-config --variable=includedir %{nspr_name}`
NSPR_LIB_DIR=`PKG_CONFIG_PATH=/usr/lib64/pkgconfig /usr/bin/pkg-config --variable=libdir %{nspr_name}`
%endif

%ifarch sparcv9
NSPR_INCLUDE_DIR=`PKG_CONFIG_PATH=/usr/lib/sparcv9/pkgconfig /usr/bin/pkg-config --variable=includedir %{base_nspr_name}`
NSPR_LIB_DIR=`PKG_CONFIG_PATH=/usr/lib/sparcv9/pkgconfig /usr/bin/pkg-config --variable=libdir %{base_nspr_name}`
NSS_INCLUDE_DIR=`PKG_CONFIG_PATH=/usr/lib/sparcv9/pkgconfig /usr/bin/pkg-config --variable=includedir %{base_nss_name}`
NSS_LIB_DIR=`PKG_CONFIG_PATH=/usr/lib/sparcv9/pkgconfig /usr/bin/pkg-config --variable=libdir %{base_nss_name}`
%endif

export NSS_INCLUDE_DIR
export NSS_LIB_DIR

export NSPR_INCLUDE_DIR
export NSPR_LIB_DIR

%ifarch x86_64 ppc64 ia64 s390x sparcv9
USE_64=1
export USE_64
%endif

%ifarch x86_64
JAVA_HOME=/usr/lib/jvm/java-1.4.2-ibm.x86_64
export JAVA_HOME
%endif

%ifarch i386
JAVA_HOME=/usr/lib/jvm/java-1.4.2-ibm
export JAVA_HOME
%endif

# Make CORECONF and JSS
make -C ./mozilla/security/coreconf
make -C ./mozilla/security/jss

%install
rm -rf ${RPM_BUILD_ROOT}

# There is no install target so we'll do it by hand

%ifarch sparcv9
%define undefined_jnidir  %(test "%{_jnidir}"="" && echo 1 || echo 0)
%if %{undefined_jnidir}
%define _jnidir         %{_libdir}/java
%endif

install -d ${RPM_BUILD_ROOT}%{_libdir}/sparcv9/dirsec
install -d ${RPM_BUILD_ROOT}%{_libdir}/sparcv9/java/dirsec
install -d ${RPM_BUILD_ROOT}%{_jnidir}/dirsec
%else
install -d ${RPM_BUILD_ROOT}%{_libdir}/dirsec
install -d ${RPM_BUILD_ROOT}%{_libdir}/java/dirsec
install -d ${RPM_BUILD_ROOT}%{_jnidir}/dirsec
%endif

%ifarch sparcv9
cp mozilla/dist/xpclass.jar ${RPM_BUILD_ROOT}%{_jnidir}/dirsec/jss-%{version}.jar
cp mozilla/dist/*.OBJ/lib/libjss4.so ${RPM_BUILD_ROOT}%{_libdir}/sparcv9/dirsec
cd ${RPM_BUILD_ROOT}%{_libdir}/sparcv9/java/dirsec
pushd ${RPM_BUILD_ROOT}%{_jnidir}/dirsec
    ln -sf jss-%{version}.jar jss4.jar
popd
pushd ${RPM_BUILD_ROOT}%{_libdir}/sparcv9/java/dirsec
    # symlink to support application that uses the old location
    ln -sf %{_jnidir}/dirsec/jss-%{version}.jar jss-%{version}.jar
    ln -sf %{_jnidir}/dirsec/jss4.jar jss4.jar
popd
%else
cp mozilla/dist/xpclass.jar ${RPM_BUILD_ROOT}%{_jnidir}/dirsec/jss-%{version}.jar
cp mozilla/dist/*.OBJ/lib/libjss4.so ${RPM_BUILD_ROOT}%{_libdir}/dirsec

# temporarily omit rpm-sign, need to reconstruct dependencies
#cd ${RPM_BUILD_ROOT}%{_jnidir}/dirsec ;
#rpm-sign --jarsign --key jcesigncert jss-%{version}.jar
pushd ${RPM_BUILD_ROOT}%{_jnidir}/dirsec
    ln -sf jss-%{version}.jar jss4.jar
popd

%ifarch x86_64
pushd ${RPM_BUILD_ROOT}%{_libdir}/java/dirsec
    # symlink to support application that uses the old location
    ln -sf %{_jnidir}/dirsec/jss-%{version}.jar jss-%{version}.jar
    ln -sf %{_jnidir}/dirsec/jss4.jar jss4.jar
popd
%endif
%endif

%files
%ifos Solaris
%attr(00755,root,sys)   %dir %{_prefix}
%attr(00755,root,bin)   %dir %{_libdir}
%endif
%ifarch sparc
%attr(00755,root,bin)   %dir %{_jnidir}
%attr(00755,root,other) %dir %{_jnidir}/dirsec
%attr(00644,root,other)      %{_jnidir}/dirsec/jss-4.2.4.jar
%attr(00777,root,other)      %{_jnidir}/dirsec/jss4.jar
%attr(00755,root,other) %dir %{_libdir}/dirsec
%attr(00755,root,other)      %{_libdir}/dirsec/libjss4.so
%attr(00644,root,other)      %{_libdir}/java/dirsec/jss-4.2.4.jar
%attr(00777,root,other)      %{_libdir}/java/dirsec/jss4.jar
%endif
%ifarch sparcv9
%attr(00755,root,bin)   %dir %{_jnidir}
%attr(00755,root,other) %dir %{_jnidir}/dirsec
%attr(00644,root,other)      %{_jnidir}/dirsec/jss-4.2.4.jar
%attr(00777,root,other)      %{_jnidir}/dirsec/jss4.jar
%attr(00755,root,bin)   %dir %{_libdir}/sparcv9
%attr(00755,root,other) %dir %{_libdir}/sparcv9/dirsec
%attr(00755,root,bin)   %dir %{_libdir}/sparcv9/java
%attr(00755,root,other) %dir %{_libdir}/sparcv9/java/dirsec
%attr(00755,root,other)      %{_libdir}/sparcv9/dirsec/libjss4.so
%attr(00644,root,other)      %{_libdir}/sparcv9/java/dirsec/jss-4.2.4.jar
%attr(00777,root,other)      %{_libdir}/sparcv9/java/dirsec/jss4.jar
%else
%attr(-,root,root) %{_jnidir}/dirsec/jss*
%attr(-,root,root) %{_libdir}/java/dirsec/jss*
%attr(-,root,root) %{_libdir}/dirsec/lib*
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Thu Sep 06 2007 Margaret Lum <mlum@redhat.com> 4.2.4-41el4idm
- Revert to java 1.4.2. Use IBM.

* Thu Aug 16 2007 Thomas kwan <nkwan@redhat.com> 4.2.4-31el4idm
- Put dirsec back into the symlinks

* Thu Aug 16 2007 Thomas kwan <nkwan@redhat.com> 4.2.4-30el4idm
- Adjusted spec for Solaris

* Wed Aug 15 2007 Nathan Kinder <nkinder@redhat.com> 4.2.4-29el4idm
- Corrected symlinks.

* Wed Aug 15 2007 Nathan Kinder <nkinder@redhat.com> 4.2.4-28el4idm
- Fixed a pushd/popd problem in symlink creation.  Also ensured
  that we create symlinks in libdir for backwards compatibility.

* Wed Aug 15 2007 Margaret Lum <mlum@redhat.com> 4.2.4-27el4idm
- Fixed typo for java-devel.
- Add in LD_PRELOAD for bug 232224
- Pull ibm into BuildRequires
- Omit signing temporarily
- Use jnidir, not libdir for jar symlinks

* Tue Aug 14 2007 Thomas Kwan <nkwan@redhat.com> 4.2.4-21el4idm
- Built specifically with javac-ibm

* Tue Aug 14 2007 Margaret Lum <mlum@redhat.com> 4.2.4-20el4idm
- Built specifically with javac-bea

* Tue Aug 14 2007 Margaret Lum <mlum@redhat.com> 4.2.4-19el4idm
- Add gcj and devel BuildRequires, fixed typo

* Mon Aug 13 2007 Thomas Kwan <nkwan@redhat.com> 4.2.4-17el4idm
- Bumped rev to 17

* Mon Aug 13 2007 Thomas Kwan <nkwan@redhat.com> 4.2.4-16el4idm
- Changed JAVA_HOME to /usr

* Mon Aug 13 2007 Thomas Kwan <nkwan@redhat.com> 4.2.4-13el4idm
- Used JAVA_HOME=/usr/lib/jvm/java-1.4.2-gcj-1.4.2.0

* Mon Aug 13 2007 Thomas Kwan <nkwan@redhat.com> 4.2.4-11el4idm
- Put /usr/sbin/alternatives in to detect the location of javac

* Mon Aug 13 2007 Thomas Kwan <nkwan@redhat.com> 4.2.4-10el4idm
- Tried to set JAVA_HOME to /usr
- Bumped spec rev to 10 

* Mon Aug 13 2007 Thomas Kwan <nkwan@redhat.com> 4.2.4-9el4idm
- Used java-gcj as JAVA_HOME
- Bumped spec rev to 9

* Fri Aug 10 2007 Thomas Kwan <nkwan@redhat.com> 4.2.4-8el4idm
- Bumped spec rev to 8

* Fri Aug 10 2007 Thomas Kwan <nkwan@redhat.com> 4.2.4-7el4idm
- Bumped spec rev to 7

* Fri Aug 10 2007 Thomas Kwan <nkwan@redhat.com> 4.2.4-6el4idm
- Used _jnidir on Linux so that jar file will be in arch-independent location
- Kept ${_libdir} for supporting legacy CS

* Wed Jun 14 2007 Margaret Lum <mlum@redhat.com> 4.2.4-5el4idm
- Set JAVA_HOME for build_java.pl

* Wed Jun 13 2007 Margaret Lum <mlum@redhat.com> 4.2.4-4el4idm
- Remove KEYSTORE_PATH env usage

* Wed Jun 13 2007 Margaret Lum <mlum@redhat.com> 4.2.4-3el4idm
- Building on IDMCOMMON branch, use disttag el4idm
- Replace jarsigner with rpm-sign (Linux-only)

* Thu Apr  3 2007 Rob Crittenden <rcritten@redhat.com> 4.2.4-3
- Include client authentication patch from Mozilla bug 370970
- Combine the Solaris and Linux sections in the spec file

* Tue Oct 10 2006 Matthew Harmsen <mharmsen@redhat.com> 4.2.4-2
- Bumped Release number to 2
- Updated the RPM Requires and BuildRequires to NSS 3.11.3
- Updated the RPM Requires and BuildRequires to NSPR 4.6.3

* Wed Aug 2 2006 Matthew Harmsen <mharmsen@redhat.com> 4.2.4-1
- Updated to JSS 4.2.4 (tag JSS_4_2_4_RTM)
- Added the keyword "SourcePackage" with the desired value to the SOLARIS
  section of this template.

* Mon Jul 31 2006 Matthew Harmsen <mharmsen@redhat.com> 4.2.1-1
- Updated to JSS 4.2.1 (did NOT update tag JSS_TIP_20060404)!

* Mon Apr 3 2006 Matthew Harmsen <mharmsen@redhat.com> 4.2-1
- Removed need for "dirsec-nspr-config" and "dirsec-nss-config" executables.

* Tue Feb 28 2006 Matthew Harmsen <mharmsen@redhat.com> 4.2-1
- Changed specfile to obtain all keystore information from
  environment variables (rather than hard-coded values).

* Fri Feb 24 2006 Matthew Harmsen <mharmsen@redhat.com> 4.2-1
- Applied specfile separation of Linux and Solaris.

* Wed Feb 15 2006 Matthew Harmsen <mharmsen@redhat.com> 4.2-1
- Modified specfile to build both 32-bit and 64-bit binaries
  on both Linux and Solaris. Updated template from JSS 3.7 to JSS 4.2.

* Fri Dec 16 2005 Matthew Harmsen <mharmsen@redhat.com> 3.7-1
- For use with CS 7.2 and DS 7.2 that uses the system NSPR and NSS on RHEL4
  platforms; based upon NSPR 4.4.1, and NSS 3.11, as well as previous work.
